/*
 * Copyright 2007, 2008, 2009 PathScale, LLC.  All Rights Reserved.
 */

/*
 *  Copyright (C) 2007. QLogic Corporation. All Rights Reserved.
 */

/*
 * Copyright 2003, 2004, 2005, 2006 PathScale, Inc.  All Rights Reserved.
 */

/*

  Copyright (C) 2000, 2001 Silicon Graphics, Inc.  All Rights Reserved.

   Path64 is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Path64 is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
   License for more details.

   You should have received a copy of the GNU General Public License
   along with Path64; see the file COPYING.  If not, write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.

   Special thanks goes to SGI for their continued support to open source

*/

#include "intrn_info.h"

// On many platforms, the native dynamic libm defines functions that
// we want to use, but it hides the leading underscore characters from
// us.

#if defined(TARG_X8664) || defined(TARG_IA32)
#define __
#else
#define __ "__"
#endif
const intrn_info_t intrn_info[INTRINSIC_LAST+1] = {
  { /* NONE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "__powii"},
  { /* I8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, NULL, "__powll"},
  { /* F4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, NULL, "powf"},
  { /* F8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, NULL, "pow"},
  { /* FQEXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, NULL, "qpow"},
  { /* F16EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, NULL, "qpow"},
  { /* C4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, NULL, "__powcc"},
  { /* C8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, NULL, "__powzz"},
  { /* CQEXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, NULL, "__cqpow"},
  { /* C16EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, NULL, "__cqpow"},
  { /* F4I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, NULL, "__powri"},
  { /* F4I8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, NULL, "__powrl"},
  { /* F8I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, NULL, "__powdi"},
  { /* F8I8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, NULL, "__powdl"},
  { /* FQI4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, NULL, "__pow_qi"},
  { /* FQI8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, NULL, "__pow_ql"},
  { /* F16I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, NULL, "__pow_qi"},
  { /* F16I8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, NULL, "__pow_ql"},
  { /* C4I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, NULL, "__powci"},
  { /* C4I8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, NULL, "__powcl"},
  { /* C8I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, NULL, "__powzi"},
  { /* C8I8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, NULL, "__powzl"},
  { /* CQI4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, NULL, "__powcqi"},
  { /* CQI8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, NULL, "__powcql"},
  { /* C16I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, NULL, "__powcqi"},
  { /* C16I8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, NULL, "__powcql"},
  { /* CEQEXPR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "s_cmp"},
  { /* CNEEXPR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "s_cmp"},
  { /* CGEEXPR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "s_cmp"},
  { /* CGTEXPR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "s_cmp"},
  { /* CLEEXPR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "s_cmp"},
  { /* CLTEXPR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, "s_cmp"},
  { /* SUBSTRINGEXPR */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, NULL, "s_copy"},
  { /* CONCATEXPR */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, NULL, "s_cat"},
  { /* CASSIGNSTMT */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, NULL, "s_copy"},
  { /* I2ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIABS", "h_abs"},
  { /* I4ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIABS", "i_abs"},
  { /* I8ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIABS", "l_abs"},
  { /* F4ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ABS", "r_abs"},
  { /* F8ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DABS", "d_abs"},
  { /* FQABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QABS", "__q_abs"},
  { /* F16ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QABS", "__q_abs"},
  { /* F4C4ABS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "CABS", "__c8abs"},
  { /* F4C4ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "CABS", "c_abs_"},
  { /* F8C8ABS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "ZABS", "__zabs"},
  { /* F8C8ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "ZABS", "z_abs_"},
  { /* FQCQABS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "CQABS", "__cqabs"},
  { /* FQCQABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "CQABS", "__cq_abs"},
  { /* F16C16ABS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "CQABS", "__cqabs"},
  { /* F16C16ABSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "CQABS", "__cq_abs"},
  { /* I2MODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IMOD", "h_mod"},
  { /* I4MODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JMOD", "i_mod"},
  { /* I8MODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KMOD", "l_mod"},
  { /* F4MOD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "AMOD", "__rmod"},
  { /* F4MODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "AMOD", "r_mod"},
  { /* F8MOD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DMOD", "__dmod"},
  { /* F8MODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DMOD", "d_mod"},
  { /* FQMOD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QMOD", "__qmod"},
  { /* FQMODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QMOD", "__q_mod"},
  { /* F16MOD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QMOD", "__qmod"},
  { /* F16MODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QMOD", "__q_mod"},
  { /* F4SQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SQRT", "r_sqrt"},
  { /* F8SQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSQRT", "d_sqrt"},
  { /* FQSQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSQRT", "__q_sqrt"},
  { /* F16SQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QSQRT", "__q_sqrt"},
  { /* C4SQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CSQRT", "c_sqrt_"},
  { /* C8SQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZSQRT", "z_sqrt_"},
  { /* CQSQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQSQRT", "__cq_sqrt"},
  { /* C16SQRTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, "CQSQRT", "__cq_sqrt"},
  { /* C4CONJG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CONJG", "__rconjg"},
  { /* C4CONJGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CONJG", "r_cnjg_"},
  { /* C8CONJG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "DCONJG", "__dconjg"},
  { /* C8CONJGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "DCONJG", "d_cnjg_"},
  { /* CQCONJG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "QCONJG", "__qconjg"},
  { /* CQCONJGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "QCONJG", "__cq_conjg"},
  { /* C16CONJG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, "QCONJG", "__qconjg"},
  { /* C16CONJGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, "QCONJG", "__cq_conjg"},
  { /* I1DIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "DIM", "b_dim"},
  { /* I2DIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIDIM", "h_dim"},
  { /* I2DIMe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIDIM", "h_dim"},
  { /* I4DIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIDIM", "i_dim"},
  { /* I4DIMe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIDIM", "i_dim"},
  { /* I8DIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIDIM", "l_dim"},
  { /* I8DIMe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIDIM", "l_dim"},
  { /* F4DIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "DIM", "r_dim"},
  { /* F4DIMe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "DIM", "r_dim"},
  { /* F8DIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DDIM", "d_dim"},
  { /* F8DIMe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DDIM", "d_dim"},
  { /* FQDIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QDIM", "__qdim"},
  { /* FQDIMe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QDIM", "__qdim"},
  { /* F16DIM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QDIM", "__qdim"},
  { /* F16DIMe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QDIM", "__qdim"},
  { /* F8F4PROD */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DPROD", "d_prod"},
  { /* F8F4PRODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DPROD", "d_prod"},
  { /* FQF8PROD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QPROD", "__qprod"},
  { /* FQF8PRODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QPROD", "__q_prod"},
  { /* F16F8PROD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QPROD", "__qprod"},
  { /* F16F8PRODe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QPROD", "__q_prod"},
  { /* I1SIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "SIGN", "__bsign"},
  { /* I2SIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IISIGN", "__hsign"},
  { /* I2SIGNe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IISIGN", "h_sign"},
  { /* I4SIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JISIGN", "__isign"},
  { /* I4SIGNe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JISIGN", "i_sign"},
  { /* I8SIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KISIGN", "__lsign"},
  { /* I8SIGNe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KISIGN", "l_sign"},
  { /* F4SIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SIGN", "__rsign"},
  { /* F4SIGNe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SIGN", "r_sign"},
  { /* F8SIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSIGN", "__dsign"},
  { /* F8SIGNe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSIGN", "d_sign"},
  { /* FQSIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSIGN", "__qsign"},
  { /* FQSIGNe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSIGN", "__q_sign"},
  { /* F16SIGN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QSIGN", "__qsign"},
  { /* F16SIGNe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QSIGN", "__q_sign"},
  { /* F4IMAGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "IMAG", "r_imag"},
  { /* F8IMAGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DIMAG", "d_imag"},
  { /* FQIMAGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QIMAG", "__cq_imag"},
  { /* F16IMAGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QIMAG", "__cq_imag"},
  { /* F4AINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "AINT", "truncf"},
  { /* F4AINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "AINT", "r_int"},
  { /* F8AINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DINT", "trunc"},
  { /* F8AINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DINT", "d_int"},
  { /* FQAINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QINT", "__qint"},
  { /* FQAINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QINT", "__q_int"},
  { /* F16AINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QINT", "__qint"},
  { /* F16AINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QINT", "__q_int"},
  { /* I2F4INTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IINT", "__iirint"},
  { /* I4F4INTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JINT", "__jirint"},
  { /* I8F4INTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KINT", "__kirint"},
  { /* I2F8IDINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIDINT", "__iidint"},
  { /* I4F8IDINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIDINT", "__jidint"},
  { /* I8F8IDINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIDINT", "__kidint"},
  { /* I2FQIQINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIQINT", "__iiqint"},
  { /* I4FQIQINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIQINT", "__jiqint"},
  { /* I8FQIQINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIQINT", "__kiqint"},
  { /* I2F16IQINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIQINT", "__iiqint"},
  { /* I4F16IQINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIQINT", "__jiqint"},
  { /* I8F16IQINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIQINT", "__kiqint"},
  { /* I2F4NINT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "ININT", "h_nint"},
  { /* I2F4NINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "ININT", "h_nint"},
  { /* I4F4NINT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JNINT", "i_nint"},
  { /* I4F4NINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JNINT", "i_nint"},
  { /* I8F4NINT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KNINT", "l_nint"},
  { /* I8F4NINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KNINT", "l_nint"},
  { /* I2F8IDNINT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIDNNT", "h_dnnt"},
  { /* I2F8IDNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIDNNT", "h_dnnt"},
  { /* I4F8IDNINT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIDNNT", "i_dnnt"},
  { /* I4F8IDNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIDNNT", "i_dnnt"},
  { /* I8F8IDNINT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIDNNT", "l_dnnt"},
  { /* I8F8IDNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIDNNT", "l_dnnt"},
  { /* I2FQIQNINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIQNNT", "__iiqnnt"},
  { /* I2FQIQNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIQNNT", "__ii_qnnt"},
  { /* I4FQIQNINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIQNNT", "__jiqnnt"},
  { /* I4FQIQNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIQNNT", "__ji_qnnt"},
  { /* I8FQIQNINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIQNNT", "__kiqnnt"},
  { /* I8FQIQNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIQNNT", "__ki_qnnt"},
  { /* I2F16IQNINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIQNNT", "__iiqnnt"},
  { /* I2F16IQNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIQNNT", "__ii_qnnt"},
  { /* I4F16IQNINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIQNNT", "__jiqnnt"},
  { /* I4F16IQNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIQNNT", "__ji_qnnt"},
  { /* I8F16IQNINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIQNNT", "__kiqnnt"},
  { /* I8F16IQNINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIQNNT", "__ki_qnnt"},
  { /* F4ANINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ANINT", "__rnint"},
  { /* F4ANINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ANINT", "r_nint"},
  { /* F8ANINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DNINT", "__dnint"},
  { /* F8ANINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DNINT", "d_nint"},
  { /* FQANINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QNINT", "__qnint"},
  { /* FQANINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QNINT", "__q_nint"},
  { /* F16ANINT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QNINT", "__qnint"},
  { /* F16ANINTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QNINT", "__q_nint"},
  { /* I2BNOTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "INOT", "not_h"},
  { /* I4BNOTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JNOT", "not_l"},
  { /* I8BNOTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KNOT", "not_ll"},
  { /* I2BANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIAND", "and_h"},
  { /* I4BANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIAND", "and_l"},
  { /* I8BANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIAND", "and_ll"},
  { /* I2BIORe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIOR", "or_h"},
  { /* I4BIORe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIOR", "or_l"},
  { /* I8BIORe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIOR", "or_ll"},
  { /* I2BXORe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIEOR", "xor_h"},
  { /* I4BXORe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIEOR", "xor_l"},
  { /* I8BXORe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIEOR", "xor_ll"},
  { /* I1BITS */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "IBITS", "bext_b"},
  { /* I2BITS */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIBITS", "bext_h"},
  { /* I2BITSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIBITS", "bext_h"},
  { /* I4BITS */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIBITS", "bext_l"},
  { /* I4BITSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIBITS", "bext_l"},
  { /* I8BITS */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIBITS", "bext_ll"},
  { /* I8BITSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIBITS", "bext_ll"},
  { /* I1BSET */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "IBSET", "bset_b"},
  { /* I2BSET */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIBSET", "bset_h"},
  { /* I2BSETe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIBSET", "bset_h"},
  { /* I4BSET */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIBSET", "bset_l"},
  { /* I4BSETe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIBSET", "bset_l"},
  { /* I8BSET */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIBSET", "bset_ll"},
  { /* I8BSETe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIBSET", "bset_ll"},
  { /* I1BCLR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "IBCLR", "bclr_b"},
  { /* I2BCLR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIBCLR", "bclr_h"},
  { /* I2BCLRe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IIBCLR", "bclr_h"},
  { /* I4BCLR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIBCLR", "bclr_l"},
  { /* I4BCLRe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JIBCLR", "bclr_l"},
  { /* I8BCLR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIBCLR", "bclr_ll"},
  { /* I8BCLRe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KIBCLR", "bclr_ll"},
  { /* I1BTEST */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "BTEST", "btest_b"},
  { /* I2BTEST */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "BITEST", "btest_h"},
  { /* I2BTESTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "BITEST", "btest_h"},
  { /* I4BTEST */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "BJTEST", "btest_l"},
  { /* I4BTESTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "BJTEST", "btest_l"},
  { /* I8BTEST */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "BKTEST", "btest_ll"},
  { /* I8BTESTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "BKTEST", "btest_ll"},
  { /* I1MVBITS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "MVBITS", "mvbits_byte"},
  { /* I2MVBITS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "MVBITS", "mvbits_short"},
  { /* I4MVBITS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "MVBITS", "mvbits_long"},
  { /* I8MVBITS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "MVBITS", "mvbits_long_long"},
  { /* I1SHL */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, "_I4SHL", "LSHIFT", "shft_b"},
  { /* I2SHL */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, "_I4SHL", "LSHIFT", "shft_h"},
  { /* I1SHR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "RSHIFT", "rshft_b"},
  { /* I2SHR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "RSHIFT", "rshft_h"},
  { /* I1SHFT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "ISHFT", "shft_b"},
  { /* I2SHFT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IISHFT", "shft_h"},
  { /* I2SHFTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IISHFT", "shft_h"},
  { /* I4SHFT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JISHFT", "shft_l"},
  { /* I4SHFTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JISHFT", "shft_l"},
  { /* I8SHFT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KISHFT", "shft_ll"},
  { /* I8SHFTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KISHFT", "shft_ll"},
  { /* I1SHFTC */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "ISHFTC", "shftc_b"},
  { /* I2SHFTC */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IISHFTC", "shftc_h"},
  { /* I2SHFTCe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "IISHFTC", "shftc_h"},
  { /* I4SHFTC */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JISHFTC", "shftc_l"},
  { /* I4SHFTCe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "JISHFTC", "shftc_l"},
  { /* I8SHFTC */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KISHFTC", "shftc_ll"},
  { /* I8SHFTCe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "KISHFTC", "shftc_ll"},
  { /* I4CLEN */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LEN", "i_len"},
  { /* I4CLENe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LEN", "i_len"},
  { /* I4CINDEX */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "INDEX", "i_indx"},
  { /* I4CINDEXe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "INDEX", "i_indx"},
  { /* CLGE */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LGE", "l_ge"},
  { /* CLGEe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LGE", "l_ge"},
  { /* CLGT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LGT", "l_gt"},
  { /* CLGTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LGT", "l_gt"},
  { /* CLLE */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LLE", "l_le"},
  { /* CLLEe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LLE", "l_le"},
  { /* CLLT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LLT", "l_lt"},
  { /* CLLTe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, "LLT", "l_lt"},
  { /* F4EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "EXP", "expf"},
  { /* F4EXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "EXP", "r_exp"},
  { /* F8EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DEXP", "exp"},
  { /* F8EXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DEXP", "d_exp"},
  { /* FQEXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QEXP", "__qexp"},
  { /* FQEXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QEXP", "__q_exp"},
  { /* F16EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QEXP", "__qexp"},
  { /* F16EXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QEXP", "__q_exp"},
  { /* C4EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CEXP", "__cexp"},
  { /* C4EXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CEXP", "c_exp_"},
  { /* C8EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZEXP", "__zexp"},
  { /* C8EXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZEXP", "z_exp_"},
  { /* CQEXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQEXP", "__cqexp"},
  { /* CQEXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQEXP", "__cq_exp"},
  { /* C16EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, "CQEXP", "__cqexp"},
  { /* C16EXPe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, "CQEXP", "__cq_exp"},
  { /* F4LOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ALOG", "logf"},
  { /* F4LOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ALOG", "r_log"},
  { /* F8LOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DLOG", "log"},
  { /* F8LOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DLOG", "d_log"},
  { /* FQLOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QLOG", "__qlog"},
  { /* FQLOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QLOG", "__q_log"},
  { /* F16LOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QLOG", "__qlog"},
  { /* F16LOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QLOG", "__q_log"},
  { /* C4LOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CLOG", "__clog"},
  { /* C4LOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CLOG", "c_log_"},
  { /* C8LOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZLOG", "__zlog"},
  { /* C8LOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZLOG", "z_log_"},
  { /* CQLOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQLOG", "__cqlog"},
  { /* CQLOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQLOG", "__cq_log"},
  { /* C16LOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, "CQLOG", "__cqlog"},
  { /* C16LOGe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, "CQLOG", "__cq_log"},
  { /* F4LOG10 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ALOG10", "log10f"},
  { /* F4LOG10e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ALOG10", "r_lg10"},
  { /* F8LOG10 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DLOG10", "log10"},
  { /* F8LOG10e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DLOG10", "d_lg10"},
  { /* FQLOG10 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QLOG10", "log10l"},
  { /* FQLOG10e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QLOG10", "__q_lg10"},
  { /* F16LOG10 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QLOG10", "log10l"},
  { /* F16LOG10e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QLOG10", "__q_lg10"},
  { /* F4GAMMA */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "AGAMMA", "tgammaf"},
  { /* F8GAMMA */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DGAMMA", "tgamma"},
  { /* FQGAMMA */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QGAMMA", "tgammal"},
  { /* F4LOG_GAMMA */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ALOG_GAMMA", "lgammaf"},
  { /* F8LOG_GAMMA */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DLOG_GAMMA", "lgamma"},
  { /* FQLOG_GAMMA */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QLOG_GAMMA", "lgammal"},
  { /* F4COS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "COS", "cosf"},
  { /* F4COSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "COS", "r_cos"},
  { /* F8COS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DCOS", "cos"},
  { /* F8COSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DCOS", "d_cos"},
  { /* FQCOS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QCOS", "__qcos"},
  { /* FQCOSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QCOS", "__q_cos"},
  { /* F16COS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QCOS", "__qcos"},
  { /* F16COSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QCOS", "__q_cos"},
  { /* C4COS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CCOS", "__ccos"},
  { /* C4COSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CCOS", "c_cos_"},
  { /* C8COS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZCOS", "__zcos"},
  { /* C8COSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZCOS", "z_cos_"},
  { /* CQCOS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQCOS", "__cqcos"},
  { /* CQCOSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQCOS", "__cq_cos"},
  { /* C16COS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, "CQCOS", "__cqcos"},
  { /* C16COSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, "CQCOS", "__cq_cos"},
  { /* F4SIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SIN", "sinf"},
  { /* F4SINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SIN", "r_sin"},
  { /* F8SIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSIN", "sin"},
  { /* F8SINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSIN", "d_sin"},
  { /* FQSIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSIN", "__qsin"},
  { /* FQSINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSIN", "__q_sin"},
  { /* F16SIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QSIN", "__qsin"},
  { /* F16SINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QSIN", "__q_sin"},
  { /* C4SIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CSIN", "__csin"},
  { /* C4SINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CSIN", "c_sin_"},
  { /* C8SIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZSIN", "__zsin"},
  { /* C8SINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "ZSIN", "z_sin_"},
  { /* CQSIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQSIN", "__cqsin"},
  { /* CQSINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "CQSIN", "__cq_sin"},
  { /* C16SIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, "CQSIN", "__cqsin"},
  { /* C16SINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, "CQSIN", "__cq_sin"},
  { /* F4CIS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CIS", "__rcis"},
  { /* F4CISe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, "CIS", "r_cis"},
  { /* F8CIS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "DCIS", "__dcis"},
  { /* F8CISe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, "DCIS", "d_cis"},
  { /* FQCIS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "QCIS", "__qcis"},
  { /* FQCISe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, "QCIS", "q_cis"},
  { /* F16CIS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, "QCIS", "__qcis"},
  { /* F16CISe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, "QCIS", "q_cis"},
  { /* F4TAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "TAN", "tanf"},
  { /* F4TANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "TAN", "r_tan"},
  { /* F8TAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DTAN", "tan"},
  { /* F8TANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DTAN", "d_tan"},
  { /* FQTAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QTAN", "__qtan"},
  { /* FQTANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QTAN", "__q_tan"},
  { /* F16TAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QTAN", "__qtan"},
  { /* F16TANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QTAN", "__q_tan"},
  { /* F4COSD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "COSD", "__rcosd"},
  { /* F4COSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "COSD", "r_cosd"},
  { /* F8COSD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DCOSD", "__dcosd"},
  { /* F8COSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DCOSD", "d_cosd"},
  { /* FQCOSD */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QCOSD", "__q_cosd"},
  { /* FQCOSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QCOSD", "__q_cosd"},
  { /* F16COSD */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QCOSD", "__q_cosd"},
  { /* F16COSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QCOSD", "__q_cosd"},
  { /* F4SIND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SIND", "__rsind"},
  { /* F4SINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SIND", "r_sind"},
  { /* F8SIND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSIND", "__dsind"},
  { /* F8SINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSIND", "d_sind"},
  { /* FQSIND */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSIND", "__q_sind"},
  { /* FQSINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSIND", "__q_sind"},
  { /* F16SIND */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QSIND", "__q_sind"},
  { /* F16SINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QSIND", "__q_sind"},
  { /* F4TAND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "TAND", "__rtand"},
  { /* F4TANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "TAND", "r_tand"},
  { /* F8TAND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DTAND", "__dtand"},
  { /* F8TANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DTAND", "d_tand"},
  { /* FQTAND */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QTAND", "__q_tand"},
  { /* FQTANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QTAND", "__q_tand"},
  { /* F16TAND */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QTAND", "__q_tand"},
  { /* F16TANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QTAND", "__q_tand"},
  { /* F4COSH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "COSH", "coshf"},
  { /* F4COSHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "COSH", "r_cosh"},
  { /* F8COSH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DCOSH", "cosh"},
  { /* F8COSHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DCOSH", "d_cosh"},
  { /* FQCOSH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QCOSH", "__qcosh"},
  { /* FQCOSHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QCOSH", "__q_cosh"},
  { /* F16COSH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QCOSH", "__qcosh"},
  { /* F16COSHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QCOSH", "__q_cosh"},
  { /* F4SINH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SINH", "sinhf"},
  { /* F4SINHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SINH", "r_sinh"},
  { /* F8SINH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSINH", "sinh"},
  { /* F8SINHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DSINH", "d_sinh"},
  { /* FQSINH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSINH", "__qsinh"},
  { /* FQSINHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QSINH", "__q_sinh"},
  { /* F16SINH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QSINH", "__qsinh"},
  { /* F16SINHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QSINH", "__q_sinh"},
  { /* F4TANH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "TANH", "tanhf"},
  { /* F4TANHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "TANH", "r_tanh"},
  { /* F8TANH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DTANH", "tanh"},
  { /* F8TANHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DTANH", "d_tanh"},
  { /* FQTANH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QTANH", "__qtanh"},
  { /* FQTANHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QTANH", "__q_tanh"},
  { /* F16TANH */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QTANH", "__qtanh"},
  { /* F16TANHe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QTANH", "__q_tanh"},
  { /* F4ACOS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ACOS", "acosf"},
  { /* F4ACOSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ACOS", "r_acos"},
  { /* F8ACOS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DACOS", "acos"},
  { /* F8ACOSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DACOS", "d_acos"},
  { /* FQACOS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QACOS", "__qacos"},
  { /* FQACOSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QACOS", "__q_acos"},
  { /* F16ACOS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QACOS", "__qacos"},
  { /* F16ACOSe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QACOS", "__q_acos"},
  { /* F4ASIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ASIN", "asinf"},
  { /* F4ASINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ASIN", "r_asin"},
  { /* F8ASIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DASIN", "asin"},
  { /* F8ASINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DASIN", "d_asin"},
  { /* FQASIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QASIN", "__qasin"},
  { /* FQASINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QASIN", "__q_asin"},
  { /* F16ASIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QASIN", "__qasin"},
  { /* F16ASINe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QASIN", "__q_asin"},
  { /* F4ATAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAN", "atanf"},
  { /* F4ATANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAN", "r_atan"},
  { /* F8ATAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAN", "atan"},
  { /* F8ATANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAN", "d_atan"},
  { /* FQATAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAN", "__qatan"},
  { /* FQATANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAN", "__q_atan"},
  { /* F16ATAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QATAN", "__qatan"},
  { /* F16ATANe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QATAN", "__q_atan"},
  { /* F4ACOSD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ACOSD", "__racosd"},
  { /* F4ACOSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ACOSD", "r_acosd"},
  { /* F8ACOSD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DACOSD", "__dacosd"},
  { /* F8ACOSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DACOSD", "d_acosd"},
  { /* FQACOSD */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QACOSD", "__q_acosd"},
  { /* FQACOSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QACOSD", "__q_acosd"},
  { /* F16ACOSD */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QACOSD", "__q_acosd"},
  { /* F16ACOSDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QACOSD", "__q_acosd"},
  { /* F4ASIND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ASIND", "__rasind"},
  { /* F4ASINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ASIND", "r_asind"},
  { /* F8ASIND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DASIND", "__dasind"},
  { /* F8ASINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DASIND", "d_asind"},
  { /* FQASIND */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QASIND", "__q_asind"},
  { /* FQASINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QASIND", "__q_asind"},
  { /* F16ASIND */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QASIND", "__q_asind"},
  { /* F16ASINDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QASIND", "__q_asind"},
  { /* F4ATAND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAND", "__ratand"},
  { /* F4ATANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAND", "r_atand"},
  { /* F8ATAND */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAND", "__datand"},
  { /* F8ATANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAND", "d_atand"},
  { /* FQATAND */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAND", "__q_atand"},
  { /* FQATANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAND", "__q_atand"},
  { /* F16ATAND */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QATAND", "__q_atand"},
  { /* F16ATANDe */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QATAND", "__q_atand"},
  { /* F4ATAN2 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAN2", "atan2f"},
  { /* F4ATAN2e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAN2", "r_atn2"},
  { /* F8ATAN2 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAN2", "atan2"},
  { /* F8ATAN2e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAN2", "d_atn2"},
  { /* FQATAN2 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAN2", "__qatan2"},
  { /* FQATAN2e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAN2", "__q_atn2"},
  { /* F16ATAN2 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QATAN2", "__qatan2"},
  { /* F16ATAN2e */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QATAN2", "__q_atn2"},
  { /* F4ATAN2D */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAN2D", "__ratn2d"},
  { /* F4ATAN2De */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "ATAN2D", "r_atn2d"},
  { /* F8ATAN2D */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAN2D", "__datn2d"},
  { /* F8ATAN2De */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DATAN2D", "d_atn2d"},
  { /* FQATAN2D */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAN2D", "__qatan2d"},
  { /* FQATAN2De */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "QATAN2D", "__q_atn2d"},
  { /* F16ATAN2D */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QATAN2D", "__qatan2d"},
  { /* F16ATAN2De */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "QATAN2D", "__q_atn2d"},
  { /* U4I4ALLOCA */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_alloca", "ALLOCA", NULL},
  { /* U8I8ALLOCA */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_alloca", "ALLOCA", NULL},
  { /* U4I4MALLOC */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, NULL, "MALLOC", "malloc"},
  { /* U8I8MALLOC */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, NULL, "MALLOC", "malloc"},
  { /* U4FREE */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "FREE", "free"},
  { /* U8FREE */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "FREE", "free"},
  { /* MDATE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "DATE", "date_vms"},
  { /* I1DATE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "IDATE", "idate_byte"},
  { /* I2DATE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "IDATE", "idate_short"},
  { /* I4DATE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "IDATE", "idate_long"},
  { /* I8DATE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "IDATE", "idate_long_long"},
  { /* I1ERRSNS */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ERRSNS", "errsns_byte"},
  { /* I2ERRSNS */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ERRSNS", "errsns_short"},
  { /* I4ERRSNS */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ERRSNS", "errsns_long"},
  { /* I8ERRSNS */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ERRSNS", "errsns_long_long"},
  { /* VEXIT */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "EXIT", "exit_noargs"},
  { /* I1EXIT */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "EXIT", "exit_byte"},
  { /* I2EXIT */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "EXIT", "exit_short"},
  { /* I4EXIT */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "EXIT", "exit_long"},
  { /* I8EXIT */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "EXIT", "exit_long_long"},
  { /* TIME */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "TIME", "time_vms"},
  { /* F4SECNDS */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "SECNDS", "secnds_vms"},
  { /* F8SECNDS */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "SECNDS", "dsecnds_vms"},
  { /* PAUSE */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "PAUSE", "s_paus"},
  { /* STOP */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "STOP", "s_stop"},
  { /* F4I4RAN */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "_RANF_4", "_RANF_4"},
  { /* F4I8RAN */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, NULL, NULL},
  { /* F8I4RAN */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "_RANF_8", "_RANF_8"},
  { /* F8I8RAN */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, NULL, NULL},
  { /* FQI4RAN */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, NULL, NULL},
  { /* FQI8RAN */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, NULL, NULL},
  { /* F16I4RAN */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, NULL, NULL},
  { /* F16I8RAN */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, NULL, NULL},
  { /* I4DIVFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "_I4DIVFLOOR", "INTRN_I4DIVFLOOR", NULL},
  { /* I8DIVFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "_I8DIVFLOOR", "INTRN_I8DIVFLOOR", NULL},
  { /* U4DIVFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "_U4DIVFLOOR", NULL, NULL},
  { /* U8DIVFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, "_U8DIVFLOOR", NULL, NULL},
  { /* I4DIVCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "_I4DIVCEIL", "INTRN_I4DIVCEIL", NULL},
  { /* I8DIVCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "_I8DIVCEIL", "INTRN_I8DIVCEIL", NULL},
  { /* U4DIVCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "_U4DIVCEIL", NULL, NULL},
  { /* U8DIVCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, "_U8DIVCEIL", NULL, NULL},
  { /* I4MODFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "_I4MODFLOOR", "INTRN_I4MODFLOOR", NULL},
  { /* I8MODFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "_I8MODFLOOR", "INTRN_I8MODFLOOR", NULL},
  { /* U4MODFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "_U4MODFLOOR", NULL, NULL},
  { /* U8MODFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, "_U8MODFLOOR", NULL, NULL},
  { /* I4MODCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "_I4MODCEIL", "INTRN_I4MODCEIL", NULL},
  { /* I8MODCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "_I8MODCEIL", "INTRN_I8MODCEIL", NULL},
  { /* U4MODCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "_U4MODCEIL", NULL, NULL},
  { /* U8MODCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, "_U8MODCEIL", NULL, NULL},
  { /* U4I4SETSTACKPOINTER */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_setstackpointer", "INTRN_U4I4SETSTACKPOINTER", NULL},
  { /* U8I8SETSTACKPOINTER */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_setstackpointer", "INTRN_U8I8SETSTACKPOINTER", NULL},
  { /* U4READSTACKPOINTER */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_readstackpointer", "INTRN_U4READSTACKPOINTER", NULL},
  { /* U8READSTACKPOINTER */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_readstackpointer", "INTRN_U8READSTACKPOINTER", NULL},
  { /* ADD_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__add_and_fetch", "ADD_AND_FETCH_I4", NULL},
  { /* SUB_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__sub_and_fetch", "SUB_AND_FETCH_I4", NULL},
  { /* OR_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__or_and_fetch", "OR_AND_FETCH_I4", NULL},
  { /* XOR_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__xor_and_fetch", "XOR_AND_FETCH_I4", NULL},
  { /* AND_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__and_and_fetch", "AND_AND_FETCH_I4", NULL},
  { /* NAND_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__nand_and_fetch", "NAND_AND_FETCH_I4", NULL},
  { /* FETCH_AND_ADD_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_add", "FETCH_AND_ADD_I4", NULL},
  { /* FETCH_AND_SUB_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_sub", "FETCH_AND_SUB_I4", NULL},
  { /* FETCH_AND_OR_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_or", "FETCH_AND_OR_I4", NULL},
  { /* FETCH_AND_XOR_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_xor", "FETCH_AND_XOR_I4", NULL},
  { /* FETCH_AND_AND_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_and", "FETCH_AND_AND_I4", NULL},
  { /* FETCH_AND_NAND_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_nand", "FETCH_AND_NAND_I4", NULL},
  { /* ADD_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__add_and_fetch", "ADD_AND_FETCH_I8", NULL},
  { /* SUB_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__sub_and_fetch", "SUB_AND_FETCH_I8", NULL},
  { /* OR_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__or_and_fetch", "OR_AND_FETCH_I8", NULL},
  { /* XOR_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__xor_and_fetch", "XOR_AND_FETCH_I8", NULL},
  { /* AND_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__and_and_fetch", "AND_AND_FETCH_I8", NULL},
  { /* NAND_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__nand_and_fetch", "NAND_AND_FETCH_I8", NULL},
  { /* FETCH_AND_ADD_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_add", "FETCH_AND_ADD_I8", NULL},
  { /* FETCH_AND_SUB_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_sub", "FETCH_AND_SUB_I8", NULL},
  { /* FETCH_AND_OR_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_or", "FETCH_AND_OR_I8", NULL},
  { /* FETCH_AND_XOR_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_xor", "FETCH_AND_XOR_I8", NULL},
  { /* FETCH_AND_AND_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_and", "FETCH_AND_AND_I8", NULL},
  { /* FETCH_AND_NAND_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_nand", "FETCH_AND_NAND_I8", NULL},
  { /* LOCK_TEST_AND_SET_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__lock_test_and_set", "LOCK_TEST_AND_SET_I4", NULL},
  { /* LOCK_TEST_AND_SET_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__lock_test_and_set", "LOCK_TEST_AND_SET_I8", NULL},
  { /* LOCK_RELEASE_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "__lock_release", "LOCK_RELEASE_I4", NULL},
  { /* LOCK_RELEASE_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "__lock_release", "LOCK_RELEASE_I8", NULL},
  { /* VAL_COMPARE_AND_SWAP_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__compare_and_swap", "COMPARE_AND_SWAP_I4", NULL},
  { /* VAL_COMPARE_AND_SWAP_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__compare_and_swap", "COMPARE_AND_SWAP_I8", NULL},
  { /* BOOL_COMPARE_AND_SWAP_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, "__compare_and_swap", "BOOL_COMPARE_AND_SWAP_I4", NULL},
  { /* BOOL_COMPARE_AND_SWAP_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, "__compare_and_swap", "BOOL_COMPARE_AND_SWAP_I8", NULL},
  { /* SYNCHRONIZE */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "__synchronize", "SYNCHRONIZE", NULL},
  { /* RETURN_ADDRESS */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_PV, "__return_address", "GET_RETURN_ADDRESS", NULL},
  { /* U4I1ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4I2ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4I4ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4I8ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4F4ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4F8ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4FQADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4F16ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4C4ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4C8ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4CQADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4C16ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U4VADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, NULL, NULL, NULL},
  { /* U8I1ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8I2ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8I4ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8I8ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8F4ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8F8ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8FQADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8F16ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8C4ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8C8ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8CQADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8C16ADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* U8VADRTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, NULL, NULL, NULL},
  { /* I4VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, NULL},
  { /* I8VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, NULL, NULL},
  { /* U4VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, NULL, NULL},
  { /* U8VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, NULL, NULL},
  { /* F4VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, NULL, NULL},
  { /* F8VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, NULL, NULL},
  { /* FQVALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, NULL, NULL},
  { /* F16VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, NULL, NULL},
  { /* C4VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C4, NULL, NULL, NULL},
  { /* C8VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C8, NULL, NULL, NULL},
  { /* CQVALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_CQ, NULL, NULL, NULL},
  { /* C16VALTMP */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_C16, NULL, NULL, NULL},
  { /* BCOPY */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "bcopy", "BCOPY", "bcopy"},
  { /* BCMP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "bcmp", "BCMP", "bcmp"},
  { /* BZERO */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "bzero", "BZERO", "bzero"},
  { /* MEMCCPY */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "memccpy", "MEMCCPY", "memccpy"},
  { /* MEMCHR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "memchr", "MEMCHR", "memchr"},
  { /* MEMCMP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "memcmp", "MEMCMP", "memcmp"},
  { /* MEMCPY */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "memcpy", "MEMCPY", "memcpy"},
  { /* MEMMOVE */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "memmove", "MEMMOVE", "memmove"},
  { /* MEMSET */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "memset", "MEMSET", "memset"},
  { /* STRCMP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "strcmp", "STRCMP", "strcmp"},
  { /* STRNCMP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "strncmp", "STRNCMP", "strncmp"},
  { /* STRCPY */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PC, "strcpy", "STRCPY", "strcpy"},
  { /* STRNCPY */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PC, "strncpy", "STRNCPY", "strncpy"},
  { /* STRLEN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_SZT, "strlen", "STRLEN", "strlen"},
  { /* STRCHR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PC, "strchr", "STRCHR", "strchr"},
  { /* STRCAT */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PC, "strcat", "STRCAT", "strcat"},
  { /* PRINTF */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "printf", "PRINTF", "printf"},
  { /* FPRINTF */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "fprintf", "FPRINTF", "fprintf"},
  { /* SPRINTF */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "sprintf", "SPRINTF", "sprintf"},
  { /* PRINTW */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "printw", "PRINTW", "printw"},
  { /* SCANF */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "scanf", "SCANF", "scanf"},
  { /* FSCANF */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "fscanf", "FSCANF", "fscanf"},
  { /* SSCANF */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "sscanf", "SSCANF", "sscanf"},
  { /* FPUTC */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "fputc", "FPUTC", "fputc"},
  { /* FPUTS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "fputs", "FPUTS", "fputs"},
  { /* FGETC */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "fgetc", "FGETC", "fgetc"},
  { /* FGETS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "fgets", "FGETS", "fgets"},
  { /* F4VACOS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vacosf", "VACOSF", "vacosf"},
  { /* F8VACOS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vacos", "VACOS", "vacos"},
  { /* F4VASIN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vasinf", "VASINF", "vasinf"},
  { /* F8VASIN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vasin", "VASIN", "vasin"},
  { /* F4VATAN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vatanf", "VATANF", "vatanf"},
  { /* F8VATAN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vatan", "VATAN", "vatan"},
  { /* F4VCOS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vcosf", "VCOSF", "vcosf"},
  { /* F8VCOS */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vcos", "VCOS", "vcos"},
  { /* F4VEXP */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vexpf", "VEXPF", "vexpf"},
  { /* F8VEXP */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vexp", "VEXP", "vexp"},
  { /* F4VLOG */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vlogf", "VLOGF", "vlogf"},
  { /* F8VLOG */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vlog", "VLOG", "vlog"},
  { /* F4VSIN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vsinf", "VSINF", "vsinf"},
  { /* F8VSIN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vsin", "VSIN", "vsin"},
  { /* F4VSQRT */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vsqrtf", "VSQRTF", "vsqrtf"},
  { /* F8VSQRT */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vsqrt", "VSQRT", "vsqrt"},
  { /* F4VTAN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vtanf", "VTANF", "vtanf"},
  { /* F8VTAN */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vtan", "VTAN", "vtan"},
  { /* NARY_ADD */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* NARY_MPY */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* U4I4TRAPUV_MALLOC */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, NULL, "TRAPUV_MALLOC", "__trapuv_malloc"},
  { /* U8I8TRAPUV_MALLOC */
	BYVAL, NOT_PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, NULL, "TRAPUV_MALLOC", "__trapuv_malloc"},
  { /* F77_BOUNDS_ERR */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, NULL, "s_rnge"},
  { /* DSM_NUMTHREADS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_NUMTHREADS", "dsm_numthreads"},
  { /* DSM_CHUNKSIZE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_CHUNKSIZE", "dsm_chunksize"},
  { /* DSM_THIS_CHUNKSIZE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_THIS_CHUNKSIZE", "dsm_this_chunksize"},
  { /* DSM_REM_CHUNKSIZE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_REM_CHUNKSIZE", "dsm_rem_chunksize"},
  { /* DSM_NUMCHUNKS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_NUMCHUNKS", "dsm_numchunks"},
  { /* DSM_THIS_THREADNUM */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_THIS_THREADNUM", "dsm_this_threadnum"},
  { /* DSM_DISTRIBUTION_BLOCK */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_DISTRIBUTION_BLOCK", "dsm_distribution_block"},
  { /* DSM_DISTRIBUTION_STAR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_DISTRIBUTION_STAR", "dsm_distribution_star"},
  { /* DSM_ISRESHAPED */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_ISRESHAPED", "dsm_isreshaped"},
  { /* DSM_ISDISTRIBUTED */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_ISDISTRIBUTED", "dsm_isdistributed"},
  { /* DSM_THIS_STARTINDEX */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_THIS_STARTINGINDEX", "dsm_this_startingindex"},
  { /* DSM_DISTRIBUTION_CYCLIC */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "DSM_DISTRIBUTION_CYCLIC", "dsm_distribution_cyclic"},
  { /* MPY_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__mpy_and_fetch", "MPY_AND_FETCH_I4", NULL},
  { /* MIN_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__min_and_fetch", "MIN_AND_FETCH_I4", NULL},
  { /* MAX_AND_FETCH_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__max_and_fetch", "MAX_AND_FETCH_I4", NULL},
  { /* FETCH_AND_MPY_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_mpy", "FETCH_AND_MPY_I4", NULL},
  { /* FETCH_AND_MIN_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_min", "FETCH_AND_MIN_I4", NULL},
  { /* FETCH_AND_MAX_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_max", "FETCH_AND_MAX_I4", NULL},
  { /* MPY_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__mpy_and_fetch", "MPY_AND_FETCH_I8", NULL},
  { /* MIN_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__min_and_fetch", "MIN_AND_FETCH_I8", NULL},
  { /* MAX_AND_FETCH_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__max_and_fetch", "MAX_AND_FETCH_I8", NULL},
  { /* FETCH_AND_MPY_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_mpy", "FETCH_AND_MPY_I8", NULL},
  { /* FETCH_AND_MIN_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_min", "FETCH_AND_MIN_I8", NULL},
  { /* FETCH_AND_MAX_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_max", "FETCH_AND_MAX_I8", NULL},
  { /* ADD_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__add_and_fetch", "ADD_AND_FETCH_F4", NULL},
  { /* SUB_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__sub_and_fetch", "SUB_AND_FETCH_F4", NULL},
  { /* OR_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__or_and_fetch", "OR_AND_FETCH_F4", NULL},
  { /* XOR_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__xor_and_fetch", "XOR_AND_FETCH_F4", NULL},
  { /* AND_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__and_and_fetch", "AND_AND_FETCH_F4", NULL},
  { /* NAND_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__nand_and_fetch", "NAND_AND_FETCH_F4", NULL},
  { /* MPY_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__mpy_and_fetch", "MPY_AND_FETCH_F4", NULL},
  { /* MIN_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__min_and_fetch", "MIN_AND_FETCH_F4", NULL},
  { /* MAX_AND_FETCH_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__max_and_fetch", "MAX_AND_FETCH_F4", NULL},
  { /* FETCH_AND_ADD_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_add", "FETCH_AND_ADD_F4", NULL},
  { /* FETCH_AND_SUB_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_sub", "FETCH_AND_SUB_F4", NULL},
  { /* FETCH_AND_OR_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_or", "FETCH_AND_OR_F4", NULL},
  { /* FETCH_AND_XOR_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_xor", "FETCH_AND_XOR_F4", NULL},
  { /* FETCH_AND_AND_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_and", "FETCH_AND_AND_F4", NULL},
  { /* FETCH_AND_NAND_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_nand", "FETCH_AND_NAND_F4", NULL},
  { /* FETCH_AND_MPY_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_mpy", "FETCH_AND_MPY_F4", NULL},
  { /* FETCH_AND_MIN_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_min", "FETCH_AND_MIN_F4", NULL},
  { /* FETCH_AND_MAX_F4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_max", "FETCH_AND_MAX_F4", NULL},
  { /* ADD_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__add_and_fetch", "ADD_AND_FETCH_F8", NULL},
  { /* SUB_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__sub_and_fetch", "SUB_AND_FETCH_F8", NULL},
  { /* OR_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__or_and_fetch", "OR_AND_FETCH_F8", NULL},
  { /* XOR_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__xor_and_fetch", "XOR_AND_FETCH_F8", NULL},
  { /* AND_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__and_and_fetch", "AND_AND_FETCH_F8", NULL},
  { /* NAND_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__nand_and_fetch", "NAND_AND_FETCH_F8", NULL},
  { /* MPY_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__mpy_and_fetch", "MPY_AND_FETCH_F8", NULL},
  { /* MIN_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__min_and_fetch", "MIN_AND_FETCH_F8", NULL},
  { /* MAX_AND_FETCH_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__max_and_fetch", "MAX_AND_FETCH_F8", NULL},
  { /* FETCH_AND_ADD_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_add", "FETCH_AND_ADD_F8", NULL},
  { /* FETCH_AND_SUB_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_sub", "FETCH_AND_SUB_F8", NULL},
  { /* FETCH_AND_OR_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_or", "FETCH_AND_OR_F8", NULL},
  { /* FETCH_AND_XOR_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_xor", "FETCH_AND_XOR_F8", NULL},
  { /* FETCH_AND_AND_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_and", "FETCH_AND_AND_F8", NULL},
  { /* FETCH_AND_NAND_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_nand", "FETCH_AND_NAND_F8", NULL},
  { /* FETCH_AND_MPY_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_mpy", "FETCH_AND_MPY_F8", NULL},
  { /* FETCH_AND_MIN_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_min", "FETCH_AND_MIN_F8", NULL},
  { /* FETCH_AND_MAX_F8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_DA1, "__fetch_and_max", "FETCH_AND_MAX_F8", NULL},
  { /* LOCK_ACQUIRE_I4 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "__lock_acquire", "LOCK_ACQUIRE_I4", NULL},
  { /* LOCK_ACQUIRE_I8 */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "__lock_acquire", "LOCK_ACQUIRE_I8", NULL},
  { /* F90_STACKTEMPALLOC */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* F90_HEAPTEMPALLOC */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* F90_STACKTEMPFREE */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* F90_HEAPTEMPFREE */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* F4EXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F4EXPONENT", "_EXPONENT_4"},
  { /* F8EXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F8EXPONENT", "_EXPONENT"},
  { /* FQEXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQEXPONENT", "_EXPONENT_16"},
  { /* F16EXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQEXPONENT", "_EXPONENT_16"},
  { /* F4FRACTION */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4FRACTION", "_FRACTION_4"},
  { /* F8FRACTION */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8FRACTION", "_FRACTION"},
  { /* FQFRACTION */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQFRACTION", "_FRACTION_16"},
  { /* F16FRACTION */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "FQFRACTION", "_FRACTION_16"},
  { /* F4MODULO */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4MODULO", "_modulo4"},
  { /* F8MODULO */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8MODULO", "_modulo8"},
  { /* FQMODULO */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQMODULO", "_moduloq"},
  { /* F16MODULO */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "FQMODULO", "_moduloq"},
  { /* F4NEAREST */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4NEAREST", "_NEAREST_4"},
  { /* F8NEAREST */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8NEAREST", "_NEAREST"},
  { /* FQNEAREST */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQNEAREST", "_NEAREST_16"},
  { /* F16NEAREST */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "FQNEAREST", "_NEAREST_16"},
  { /* F4RRSPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4RRSPACING", "_RRSPACING_4"},
  { /* F8RRSPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8RRSPACING", "_RRSPACING"},
  { /* FQRRSPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQRRSPACING", "_RRSPACING_16"},
  { /* F16RRSPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "FQRRSPACING", "_RRSPACING_16"},
  { /* F4SCALE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4SCALE", "_SCALE_4"},
  { /* F8SCALE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8SCALE", "_SCALE"},
  { /* FQSCALE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQSCALE", "_SCALE_16"},
  { /* F16SCALE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "FQSCALE", "_SCALE_16"},
  { /* F4SET_EXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4SET_EXPONENT", "_SET_EXPONENT_4"},
  { /* F8SET_EXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8SET_EXPONENT", "_SET_EXPONENT"},
  { /* FQSET_EXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQSET_EXPONENT", "_SET_EXPONENT_16"},
  { /* F16SET_EXPONENT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "FQSET_EXPONENT", "_SET_EXPONENT_16"},
  { /* F4SPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4SPACING", "_SPACING_4"},
  { /* F8SPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8SPACING", "_SPACING"},
  { /* FQSPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQSPACING", "_SPACING_16"},
  { /* F16SPACING */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "FQSPACING", "_SPACING_16"},
  { /* F4NEXTAFTER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4NEXTAFTER", "_IEEE_NEXT_AFTER_H"},
#ifdef KEY /* Bug 11103 */
  /* The GNU libm -m32 version of "nextafter" fails to set exceptions. If that
   * bug is fixed, we could resume calling "nextafter" directly, and for that
   * matter, we could call "nextafterf" for F4NEXTAFTER. */
  { /* F8NEXTAFTER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8NEXTAFTER", "_IEEE_NEXT_AFTER"},
#else /* KEY Bug 11103 */
  { /* F8NEXTAFTER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8NEXTAFTER", "nextafter"},
#endif /* KEY Bug 11103 */
  { /* FQNEXTAFTER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQNEXTAFTER", "qnextafter"},
  { /* F16NEXTAFTER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "FQNEXTAFTER", "qnextafter"},
  { /* F4ISNAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4ISNAN", "isnanf"},
  { /* F8ISNAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8ISNAN", "isnan"},
  { /* FQISNAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQISNAN", "isnanq"},
  { /* F16ISNAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "FQISNAN", "isnanq"},
  { /* F4SCALB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4SCALB", "ldexp"},
  { /* F8SCALB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8SCALB", "ldexp"},
  { /* FQSCALB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQSCALB", "qldexp"},
  { /* F16SCALB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "FQSCALB", "qldexp"},
#ifdef KEY /* Bug 10261 */
  /* GNU libm drem and remainder have a bug: they don't ignore the rounding
   * mode as required by C99 (and F90 ieee_rem.) Using "remainder" instead of
   * "drem" causes pathcc (and pathf90) to link the version provided by
   * libmpath, which works correctly. */
  { /* F4IEEE_REMAINDER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4IEEE_REMAINDER", "remainder"},
  { /* F8IEEE_REMAINDER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8IEEE_REMAINDER", "remainder"},
#else /* KEY Bug 10261 */
  { /* F4IEEE_REMAINDER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4IEEE_REMAINDER", "drem"},
  { /* F8IEEE_REMAINDER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8IEEE_REMAINDER", "drem"},
#endif /* KEY Bug 10261 */
  { /* FQIEEE_REMAINDER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQIEEE_REMAINDER", "_IEEE_REMAINDER_Q"},
  { /* F16IEEE_REMAINDER */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "FQIEEE_REMAINDER", "_IEEE_REMAINDER_Q"},
  { /* F4LOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4LOGB", "logb"},
  { /* F8LOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8LOGB", "logb"},
  { /* FQLOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQLOGB", "__qlogb"},
  { /* F16LOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "FQLOGB", "__qlogb"},
  { /* F4ILOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F4ILOGB", "__ilogbf"},
  { /* F8ILOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F8ILOGB", "__ilogb"},
  { /* FQILOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQILOGB", "__iqlogb"},
  { /* F16ILOGB */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQILOGB", "__iqlogb"},
  { /* F4FPCLASS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F4FPCLASS", "_fp_class_f"},
  { /* F8FPCLASS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F8FPCLASS", "_fp_class_d"},
  { /* FQFPCLASS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQFPCLASS", "_fp_class_q"},
  { /* F16FPCLASS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQFPCLASS", "_fp_class_q"},
  { /* F4FINITE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F4FINITE", "finite"},
  { /* F8FINITE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F8FINITE", "finite"},
  { /* FQFINITE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQFINITE", "__qfinite"},
  { /* F16FINITE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQFINITE", "__qfinite"},
  { /* F4UNORDERED */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F4UNORDERED", "unordered"},
  { /* F8UNORDERED */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F8UNORDERED", "unordered"},
  { /* FQUNORDERED */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQUNORDERED", "unorderedl"},
  { /* F16UNORDERED */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "FQUNORDERED", "unorderedl"},
  { /* I1POPCNT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I1POPCNT", "__popcnt1"},
  { /* I2POPCNT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I2POPCNT", "__popcnt2"},
  { /* I4POPCNT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I4POPCNT", "__popcnt4"},
  { /* I8POPCNT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I8POPCNT", "__popcnt8"},
  { /* I1LEADZ */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, NULL, "I1LEADZ", NULL},
  { /* I2LEADZ */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, NULL, "I2LEADZ", NULL},
  { /* I4LEADZ */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, NULL, "I4LEADZ", NULL},
  { /* I8LEADZ */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, NULL, "I8LEADZ", NULL},
  { /* LENTRIM */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "LENTRIM", "i_lentrim"},
  { /* F90INDEX */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "F90INDEX", "_index90"},
  { /* SCAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "SCAN", "_scan90"},
  { /* VERIFY */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "VERIFY", "_verify90"},
  { /* ADJUSTL */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ADJUSTL", "_F90_ADJUSTL"},
  { /* ADJUSTR */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ADJUSTR", "_F90_ADJUSTR"},
  { /* GET_IEEE_EXCEPTIONS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "GET_IEEE_EXCEPTIONS", "__get_ieee_exceptions"},
  { /* GET_IEEE_INTERRUPTS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "GET_IEEE_INTERRUPTS", "__get_ieee_interrupts"},
  { /* GET_IEEE_ROUNDING_MODE */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "GET_IEEE_ROUNDING_MODE", "fpgetround"},
  { /* GET_IEEE_STATUS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "GET_IEEE_STATUS", "__get_ieee_status"},
  { /* SET_IEEE_EXCEPTIONS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SET_IEEE_EXCEPTIONS", "__set_ieee_exceptions"},
  { /* SET_IEEE_EXCEPTION */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SET_IEEE_EXCEPTION", "__set_ieee_exception"},
  { /* SET_IEEE_INTERRUPTS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SET_IEEE_INTERRUPTS", "__set_ieee_interrupts"},
  { /* SET_IEEE_ROUNDING_MODE */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SET_IEEE_ROUNDING_MODE", "fpsetround"},
  { /* SET_IEEE_STATUS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SET_IEEE_STATUS", "__set_ieee_status"},
  { /* ENABLE_IEEE_INTERRUPT */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "ENABLE_IEEE_INTERRUPT", "__enable_ieee_interrupt"},
  { /* DISABLE_IEEE_INTERRUPT */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "DISABLE_IEEE_INTERRUPT", "__disable_ieee_interrupt"},
  { /* TEST_IEEE_EXCEPTION */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "TEST_IEEE_EXCEPTION", "__test_ieee_exception"},
  { /* TEST_IEEE_INTERRUPT */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "TEST_IEEE_INTERRUPT", "__test_ieee_interrupt"},
  { /* MATMUL */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* SPREAD */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* RESHAPE */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* TRANSPOSE */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* ALL */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* ANY */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* COUNT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* PRODUCT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* SUM */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* EOSHIFT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* MAXVAL */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* MINVAL */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* MAXLOC */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* MINLOC */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* CSHIFT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* DOT_PRODUCT */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* PACK */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* UNPACK */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* MERGE */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* CHAR */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* MP_IN_PARALLEL_REGION */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__mp_in_parallel_region", "__mp_in_parallel_region$", "mp_in_parallel_region"},
  { /* RT_ERR */
	NOT_BYVAL, PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, NULL, "__C_runtime_error"},
  { /* OMP_DO_WORKSHARING */
	NOT_BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__omp_do_worksharing", "__omp_do_worksharing$", "omp_do_worksharing"},
  { /* OMP_TEST_LOCK */
	NOT_BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_TEST_LOCK", "omp_test_lock_"},
  { /* OMP_GET_NUM_THREADS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_GET_NUM_THREADS", "omp_get_num_threads_"},
  { /* OMP_GET_MAX_THREADS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_GET_MAX_THREADS", "omp_get_max_threads_"},
  { /* OMP_GET_THREAD_NUM */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_GET_THREAD_NUM", "omp_get_thread_num_"},
  { /* OMP_GET_NUM_PROCS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_GET_NUM_PROCS", "omp_get_num_procs_"},
  { /* OMP_IN_PARALLEL */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_IN_PARALLEL", "omp_in_parallel_"},
  { /* OMP_GET_DYNAMIC */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_GET_DYNAMIC", "omp_get_dynamic_"},
  { /* OMP_GET_NESTED */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "OMP_GET_NESTED", "omp_get_nested_"},
  { /* I1IEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I1, NULL, "I1IEEE_INT", "_IEEE_INT_D_I1"},
  { /* I2IEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I2, NULL, "I2IEEE_INT", "_IEEE_INT_D_I2"},
  { /* I4IEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, NULL, "I4IEEE_INT", "_IEEE_INT_D_I4"},
  { /* I8IEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, NULL, "I8IEEE_INT", "_IEEE_INT_D_I8"},
  { /* F4IEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4IEEE_INT", "_IEEE_INT_D_H"},
  { /* F8IEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8IEEE_INT", "_IEEE_INT_D_R"},
  { /* FQIEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQIEEE_INT", "_IEEE_INT_D_D"},
  { /* F16IEEE_INT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "FQIEEE_INT", "_IEEE_INT_D_D"},
  { /* F90BOUNDS_CHECK */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "F90BOUNDS_CHECK", "__f90_bounds_check"},
  { /* F90_DYNAMICTEMPALLOC */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* F90_DYNAMICTEMPFREE */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_UNKNOWN, NULL, NULL, NULL},
  { /* F90CONFORM_CHECK */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "F90CONFORM_CHECK", "__f90_conform_check"},
  { /* C_F4FLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, "floorf", "C_F4FLOOR", "floorf"},
  { /* C_F8FLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, "floor", "C_F8FLOOR", "floor"},
  { /* C_FQFLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, "floorl", "C_FQFLOOR", "floorl"},
  { /* C_F16FLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, "floorl", "C_FQFLOOR", "floorl"},
  { /* C_F4CEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, "ceilf", "C_F4CEIL", "ceilf"},
  { /* C_F8CEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, "ceil", "C_F8CEIL", "ceil"},
  { /* C_FQCEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, "ceill", "C_FQCEIL", "ceill"},
  { /* C_F16CEIL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, "ceill", "C_FQCEIL", "ceill"},
  { /* C_F4TRUNC */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, "truncf", "C_F4TRUNC", "truncf"},
  { /* C_F8TRUNC */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, "trunc", "C_F8TRUNC", "trunc"},
  { /* C_FQTRUNC */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, "truncl", "C_FQTRUNC", "truncl"},
  { /* C_F16TRUNC */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, "truncl", "C_FQTRUNC", "truncl"},
  { /* I4DSHIFTL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__dshiftl4", "I4DSHIFTL", "__dshiftl4"},
  { /* I8DSHIFTL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__dshiftl8", "I8DSHIFTL", "__dshiftl8"},
  { /* I4DSHIFTR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__dshiftr4", "I4DSHIFTR", "__dshiftr4"},
  { /* I8DSHIFTR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__dshiftr8", "I8DSHIFTR", "__dshiftr8"},
  { /* I4GBIT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__gbit4", "I4GBIT", "__gbit4"},
  { /* I8GBIT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__gbit8", "I8GBIT", "__gbit8"},
  { /* I4GBITS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__gbits4", "I4GBITS", "__gbits4"},
  { /* I8GBITS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__gbits8", "I8GBITS", "__gbits8"},
  { /* I4MASK */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__mask4", "I4MASK", "__mask4"},
  { /* I8MASK */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__mask8", "I8MASK", "__mask8"},
  { /* I4MASKL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__maskl4", "I4MASKL", "__maskl4"},
  { /* I8MASKL */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__maskl8", "I8MASKL", "__maskl8"},
  { /* I4MASKR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__maskr4", "I4MASKR", "__maskr4"},
  { /* I8MASKR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__maskr8", "I8MASKR", "__maskr8"},
  { /* I4PBIT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__pbit4", "I4PBIT", "__pbit4"},
  { /* I8PBIT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__pbit8", "I8PBIT", "__pbit8"},
  { /* I4PBITS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__pbits4", "I4PBITS", "__pbits4"},
  { /* I8PBITS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__pbits8", "I8PBITS", "__pbits8"},
  { /* I4POPPAR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__poppar4", "I4POPPAR", "__poppar4"},
  { /* I8POPPAR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__poppar8", "I8POPPAR", "__poppar8"},
  { /* I4RTC */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__rtc4", "I4RTC", "__rtc4"},
  { /* I8RTC */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__rtc8", "I8RTC", "__rtc8"},
  { /* GETF_EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I8, "__builtin_getf_exp", NULL, NULL},
  { /* SETF_EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_F10, "__builtin_setf_exp", NULL, NULL},
  { /* GETF_SIG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I8, "__builtin_getf_sig", NULL, NULL},
  { /* SETF_SIG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_F10, "__builtin_setf_sig", NULL, NULL},
  { /* FMERGE_NS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F10, "__builtin_fmerge_ns", "FMERGE_NS", "__builtin_fmerge_ns"},
  { /* FMERGE_S */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F10, "__builtin_fmerge_s", "FMERGE_S", "__builtin_fmerge_s"},
  { /* FMERGE_SE */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F10, "__builtin_fmerge_se", "FMERGE_SE", "__builtin_fmerge_se"},
  { /* STOP_F90 */
	BYVAL, NOT_PURE, SIDEEFFECTS, NEVER_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "_F90_STOP", "_F90_STOP"},
  { /* F4VLOG10 */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vlog10f", "VLOG10F", "vlog10f"},
  { /* F8VLOG10 */
	NOT_BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "vlog10", "VLOG10", "vlog10"},
  { /* MODSI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__modsi3", "__modsi3", "__modsi3"},
  { /* UMODSI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "__umodsi3", "__umodsi3", "__umodsi3"},
  { /* DIVSI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "__divsi3", "__divsi3", "__divsi3"},
  { /* UDIVSI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "__udivsi3", "__udivsi3", "__udivsi3"},
  { /* MODDI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__moddi3", "__moddi3", "__moddi3"},
  { /* UMODDI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, "__umoddi3", "__umoddi3", "__umoddi3"},
  { /* DIVDI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I8, "__divdi3", "__divdi3", "__divdi3"},
  { /* UDIVDI3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U8, "__udivdi3", "__udivdi3", "__udivdi3"},
  { /* DIVSF3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, "__divsf3", "__divsf3", "__divsf3"},
  { /* DIVDF3 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, "__divdf3", "__divdf3", "__divdf3"},
#ifdef TARG_IA64
  { /* I4FFS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, "__builtin_ffs", NULL, NULL},
#elif defined(TARG_MIPS)
  { /* I4FFS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, "__builtin_ffs", NULL, NULL},
#else
  { /* I4FFS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_I4, "ffs", "I4FFS", "ffs"},
#endif
  { /* SINCOSF */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SINCOS", __"sincosf"},
  { /* SINCOS */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SINCOS", __"sincos"},
  { /* SINCOSL */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "SINCOS", __"sincosl"},
#ifdef KEY
  { /* U4READFRAMEPOINTER */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_frame_address", "INTRN_U4READFRAMEPOINTER", NULL},
  { /* U8READFRAMEPOINTER */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_PV, "__builtin_frame_address", "INTRN_U8READFRAMEPOINTER", NULL},
    { /* APPLY_ARGS */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_PV, "__builtin_apply_args", NULL, NULL},
    { /* APPLY */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_PV, "__builtin_apply", NULL, NULL},
    { /* APPLY_ARGS */
	BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V, "__builtin_return", NULL, NULL},
    { /* VA_START */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
        IRETURN_V, "__builtin_va_start", NULL, NULL},
    { /* SAVE_XMMS */
	BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V, "SAVE_XMMS", NULL, NULL},
    { /* CONSTANT_P */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, "CONSTANT_P", NULL, NULL},

    { /* ISGREATER */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "ISGREATER", NULL, NULL},
    { /* ISGREATEREQUAL */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "ISGREATEREQUAL", NULL, NULL},
    { /* ISLESS */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "ISLESS", NULL, NULL},
    { /* ISLESSEQUAL */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "ISLESSEQUAL", NULL, NULL},
    { /* ISLESSGREATER */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "ISLESSGREATER", NULL, NULL},
    { /* ISORDERED */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "ISORDERED", NULL, NULL},
    { /* ISUNORDERED */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "ISUNORDERED", NULL, NULL},

    { /* SUBSU2 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "SUBSU2", NULL, NULL},
    { /* SUBSV16I2 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "SUBSV16I2", NULL, NULL},

    { /* POPCOUNT */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "POPCOUNT", NULL, NULL},
    { /* PARITY */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "PARITY", NULL, "__paritydi2"},
    { /* CLZ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "CLZ", NULL, "__clzdi2"},
    { /* CTZ64 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_U4, "CLZ64", NULL, "__ctzdi2"},
    { /* CLZ32 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "CLZ32", NULL, NULL},
    { /* CTZ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "CTZ", NULL, NULL},
    { /* F4CBRT */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, NULL, "cbrtf"},
    { /* F8CBRT */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, NULL, "cbrt"},
    { /* INTRN_BUILTIN_EH_RETURN_DATA_REGNO */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
        IRETURN_I4, "__builtin_eh_return_data_regno", "BUILTIN_EH_RETURN_DATA_REGNO", "xxx"},

#ifdef TARG_X8664
    { /* V16F4SIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V16F4, NULL, "V16F4SIN", "__vrs4_sinf"},
    { /* V16F4EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V16F4, NULL, "V16F4EXP", "__vrs4_expf"},
    { /* V16F4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V16F4, NULL, "V16F4EXPEXPR", "__vrs4_powf"},
    { /* V16F4LOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V16F4, NULL, "V16F4LOG", "__vrs4_logf"},
    { /* V16F4COS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V16F4, NULL, "V16F4COS", "__vrs4_cosf"},

    { /* V16F8SIN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V16F8, NULL, "V16F8SIN", "__vrd2_sin"},
    { /* V16F8EXP */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V16F8, NULL, "V16F8EXP", "__vrd2_exp"},
    { /* V16F8LOG */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V16F8, NULL, "V16F8LOG", "__vrd2_log"},
    { /* V16F8COS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V16F8, NULL, "V16F8COS", "__vrd2_cos"},
    { /* V16F8EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V16F8, NULL, "V16F8EXPEXPR", "__vrd2_pow"},
    { /* V16F8LOG10 */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V16F8, NULL, "V16F8LOG10", "__vrd2_log10"},

    { /* V16F8SINCOS */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_V, NULL, "V16F8SINCOS", "__vrd2_sincos"},

    { /* V16C8MPY_ADDSUB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16C8, "V16C8MPY_ADDSUB", NULL, NULL},
    { /* V16C8CONJG */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16C8, "V16C8CONJG", NULL, NULL},  

    { /* PADDSB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I1, "PADDSB", NULL, NULL},  
    { /* PADDSW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PADDSW", NULL, NULL},  
    { /* PSUBSB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I1, "PSUBSB", NULL, NULL},  
    { /* PSUBSW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PSUBSW", NULL, NULL},  
    { /* PADDUSB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I1, "PADDUSB", NULL, NULL},  
    { /* PADDUSW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PADDUSW", NULL, NULL},  
    { /* PSUBUSB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I1, "PSUBUSB", NULL, NULL},  
    { /* PSUBUSW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PSUBUSW", NULL, NULL},  
    { /* PMULLW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PMULLW", NULL, NULL},  
    { /* PMULLW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PMULLW128", NULL, NULL},  
    { /* PMULHW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PMULHW", NULL, NULL},  
    { /* PMULHW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PMULHW128", NULL, NULL},  
    { /* PAND */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U8, "PAND", NULL, NULL},  
    { /* PCMPEQB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I1, "PCMPEQB", NULL, NULL},  
    { /* PCMPEQW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PCMPEQW", NULL, NULL},  
    { /* PCMPEQD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "PCMPEQD", NULL, NULL},  
    { /* PCMPGTB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I1, "PCMPGTB", NULL, NULL},  
    { /* PCMPGTW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PCMPGTW", NULL, NULL},  
    { /* PCMPGTD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "PCMPGTD", NULL, NULL},  
    { /* PCMPEQB128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I1, "PCMPEQB128", NULL, NULL},  
    { /* PCMPEQW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PCMPEQW128", NULL, NULL},  
    { /* PCMPEQD128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "PCMPEQD128", NULL, NULL},  
    { /* PCMPGTB128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I1, "PCMPGTB128", NULL, NULL},  
    { /* PCMPGTW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PCMPGTW128", NULL, NULL},  
    { /* PCMPGTD128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "PCMPGTD128", NULL, NULL},  
    { /* PUNPCKHBW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I1, "PUNPCKHBW", NULL, NULL},  
    { /* PUNPCKHWD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PUNPCKHWD", NULL, NULL},  
    { /* PUNPCKHDQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "PUNPCKHDQ", NULL, NULL},  
    { /* PUNPCKLBW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I1, "PUNPCKLBW", NULL, NULL},  
    { /* PUNPCKLWD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PUNPCKLWD", NULL, NULL},  
    { /* PUNPCKLDQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "PUNPCKLDQ", NULL, NULL},  
    { /* PACKSSWB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PACKSSWB", NULL, NULL},  
    { /* PACKSSDW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "PACKSSDW", NULL, NULL},  
    { /* PACKUSWB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PACKUSWB", NULL, NULL},  
    { /* PACKSSWB128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PACKSSWB128", NULL, NULL},  
    { /* PACKSSDW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "PACKSSDW128", NULL, NULL},  
    { /* PACKUSWB128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PACKUSWB128", NULL, NULL},  
    { /* PUNPCKHBW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I1, "PUNPCKHBW128", NULL, NULL},  
    { /* PUNPCKHWD128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PUNPCKHWD128", NULL, NULL},  
    { /* PUNPCKHDQ128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "PUNPCKHDQ128", NULL, NULL},  
    { /* PUNPCKHQDQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I8, "PUNPCKHQDQ", NULL, NULL},  
    { /* PUNPCKLBW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I1, "PUNPCKLBW128", NULL, NULL},  
    { /* PUNPCKLWD128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PUNPCKLWD128", NULL, NULL},  
    { /* PUNPCKLDQ128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "PUNPCKLDQ128", NULL, NULL},  
    { /* PUNPCKLQDQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I8, "PUNPCKLQDQ", NULL, NULL},  
    { /* PAVGB128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I1, "PAVGB128", NULL, NULL},  
    { /* PAVGW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PAVGW128", NULL, NULL},  
    { /* PMULHUW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PMULHUW", NULL, NULL},  
    { /* PMULHUW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PMULHUW128", NULL, NULL},  
    { /* PAVGB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I1, "PAVGB", NULL, NULL},  
    { /* PAVGW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PAVGW", NULL, NULL},  
    { /* PSADBW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I1, "PSADBW", NULL, NULL},  
    { /* PSADBW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I1, "PSADBW128", NULL, NULL},  
    { /* PMAXUB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I1, "PMAXUB", NULL, NULL},  
    { /* PMAXSW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PMAXSW", NULL, NULL},  
    { /* PMINUB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I1, "PMINUB", NULL, NULL},  
    { /* PMINSW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PMINSW", NULL, NULL},  
    { /* PMAXUB128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I1, "PMAXUB128", NULL, NULL},  
    { /* PMAXSW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PMAXSW128", NULL, NULL},  
    { /* PMINUB128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I1, "PMINUB128", NULL, NULL},  
    { /* PMULUDQ*/
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "PMULUDQ", NULL, NULL},
    { /* PMULUDQ128*/
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "PMULUDQ128", NULL, NULL},
    { /* PMINSW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PMINSW128", NULL, NULL},  
    { /* PMOVMSKB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "PMOVMSKB", NULL, NULL},  
    { /* PMOVMSKB128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "PMOVMSKB128", NULL, NULL},  
    { /* MOVNTQ */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "MOVNTQ", NULL, NULL},  
    { /* SFENCE */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "SFENCE", NULL, NULL},  
    { /* COMIEQSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "COMIEQSS", NULL, NULL},  
    { /* ADDPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "ADDPS", NULL, NULL},  
    { /* SUBPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "SUBPS", NULL, NULL},  
    { /* MULPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "MULPS", NULL, NULL},  
    { /* DIVPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "DIVPS", NULL, NULL},  
    { /* ADDSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "ADDSS", NULL, NULL},  
    { /* SUBSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "SUBSS", NULL, NULL},  
    { /* MULSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "MULSS", NULL, NULL},  
    { /* DIVSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "DIVSS", NULL, NULL},  
    { /* CMPEQPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPEQPS", NULL, NULL},  
    { /* CMPEQPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
    IRETURN_V16I4, "CMPEQPD", NULL, NULL},
    { /* CMPLTPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPLTPD", NULL, NULL},  
    { /* CMPLEPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPLEPD", NULL, NULL},  
    { /* CMPGTPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPGTPD", NULL, NULL},  
    { /* CMPGEPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPGEPD", NULL, NULL},  
    { /* CMPNEQPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNEQPD", NULL, NULL},  
    { /* CMPNLTPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNLTPD", NULL, NULL},  
    { /* CMPNLEPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNLEPD", NULL, NULL},  
    { /* CMPNGTPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNGTPD", NULL, NULL},  
    { /* CMPNGEPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNGEPD", NULL, NULL},  
    { /* CMPORDPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPORDPD", NULL, NULL},  
    { /* CMPUNORDPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPUNORDPD", NULL, NULL},  
    { /* CMPLTPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPLTPS", NULL, NULL},  
    { /* CMPLEPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPLEPS", NULL, NULL},  
    { /* CMPGTPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPGTPS", NULL, NULL},  
    { /* CMPGEPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPGEPS", NULL, NULL},  
    { /* CMPUNORDPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPUNORDPS", NULL, NULL},  
    { /* CMPNEQPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNEQPS", NULL, NULL},  
    { /* CMPNLTPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNLTPS", NULL, NULL},  
    { /* CMPNLEPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNLEPS", NULL, NULL},  
    { /* CMPNGTPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNGTPS", NULL, NULL},  
    { /* CMPNGEPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNGEPS", NULL, NULL},  
    { /* CMPORDPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPORDPS", NULL, NULL},  
    { /* CMPEQSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPEQSS", NULL, NULL},  
    { /* CMPLTSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPLTSS", NULL, NULL},  
    { /* CMPLESS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPLESS", NULL, NULL},  
    { /* CMPUNORDSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPUNORDSS", NULL, NULL},  
    { /* CMPNEQSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNEQSS", NULL, NULL},  
    { /* CMPNLTSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNLTSS", NULL, NULL},  
    { /* CMPNLESS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNLESS", NULL, NULL},  
    { /* CMPORDSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPORDSS", NULL, NULL},  
    { /* MAXPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "MAXPS", NULL, NULL},  
    { /* MAXSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "MAXSS", NULL, NULL},  
    { /* MINPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "MINPS", NULL, NULL},  
    { /* MINSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "MINSS", NULL, NULL},  
    { /* ANDPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "ANDPS", NULL, NULL},  
    { /* ANDNPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "ANDNPS", NULL, NULL},  
    { /* ORPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "ORPS", NULL, NULL},  
    { /* XORPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "XORPS", NULL, NULL},  
    { /* MOVSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "MOVSS", NULL, NULL},  
    { /* MOVHLPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "MOVHLPS", NULL, NULL},  
    { /* MOVLHPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "MOVLHPS", NULL, NULL},  
    { /* UNPCKHPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "UNPCKHPS", NULL, NULL},  
    { /* UNPCKLPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "UNPCKLPS", NULL, NULL},  
    { /* RCPPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "RCPPS", NULL, NULL},  
    { /* RSQRTPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "RSQRTPS", NULL, NULL},  
    { /* SQRTPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "SQRTPS", NULL, NULL},  
    { /* RCPSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "RCPSS", NULL, NULL},  
    { /* RSQRTSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "RSQRTSS", NULL, NULL},  
    { /* SQRTSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "SQRTSS", NULL, NULL},  
    { /* SHUFPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "SHUFPS", NULL, NULL},  
    { /* EMMS */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "EMMS", NULL, NULL},  
    { /* CLFLUSH */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "CLFLUSH", NULL, NULL},  
    { /* PADDQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U8, "PADDQ", NULL, NULL},  
    { /* PSUBQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U8, "PSUBQ", NULL, NULL},  
    // The following 2 are placeholders for builtins that are not supported.
    { /* UNIMP_PURE */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U8, "UNIMP_PURE", NULL, NULL},  
    { /* UNIMP */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "UNIMP", NULL, NULL},  
    { /* LOADAPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "LOADAPS", NULL, NULL},  
    { /* STOREAPS */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "STOREAPS", NULL, NULL},  
    { /* COSL */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_FQ, "COSL", NULL, NULL},  
    { /* SINL */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_FQ, "SINL", NULL, NULL},  
#endif // TARG_X8664
    { /* TAN */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "DTAN", "tan"},
#ifdef TARG_X8664
    { /* PSLLDQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I8, "PSLLDQ", NULL, NULL},  
    { /* PSLLW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PSLLW", NULL, NULL},  
    { /* PSLLD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "PSLLD", NULL, NULL},  
    { /* PSLLQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I8, "PSLLQ", NULL, NULL},  
    { /* PSRLW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PSRLW", NULL, NULL},  
    { /* PSRLD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "PSRLD", NULL, NULL},  
    { /* PSRLQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I8, "PSRLQ", NULL, NULL},  
    { /* PSRAW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PSRAW", NULL, NULL},  
    { /* PSRAD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "PSRAD", NULL, NULL},  
    { /* V16F4SINH */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
        IRETURN_V16F4, NULL, "V16F4SINH", "__vrs4_sinhf"},
    { /* V16F4COSH */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
        IRETURN_V16F4, NULL, "V16F4COSH", "__vrs4_coshf"},
    { /* V16F8SINH */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
        IRETURN_V16F8, NULL, "V16F8SINH", "__vrd2_sinh"},
    { /* V16F8COSH */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
        IRETURN_V16F8, NULL, "V16F8COSH", "__vrd2_cosh"},
    { /* MOVNTDQ */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "MOVNTDQ", NULL, NULL},  
    { /* LOADD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "LOADD", NULL, NULL},  
    { /* MOVNTPS */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "MOVNTPS", NULL, NULL},  
    { /* SSE_ZERO */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "SSE_ZERO", NULL, NULL},  
    { /* CLRTI */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I8, "CLRTI", NULL, NULL},  
    { /* PSHUFD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "PSHUFD", NULL, NULL},  
    { /* LOADSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "LOADSS", NULL, NULL},  
    { /* SIGNV16F4 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F4, "SIGNV16F4", NULL, NULL},
    { /* SIGNV16F8 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F4, "SIGNV16F8", NULL, NULL},
    { /* SHUFPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F8, "SHUFPD", NULL, NULL},  
    { /* XORPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F8, "XORPD", NULL, NULL},  
    { /* ANDPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F8, "ANDPD", NULL, NULL},  
    { /* ANDNPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F8, "ANDNPD", NULL, NULL},  
    { /* ORPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F8, "ORPD", NULL, NULL},  
    { /* STORELPD */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "STORELPD", NULL, NULL},  
    { /* STOREHPD */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "STOREHPD", NULL, NULL},  
    { /* LOADLPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F8, "LOADLPD", NULL, NULL},  
    { /* LOADHPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F8, "LOADHPD", NULL, NULL},  
    { /* UNPCKLPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F8, "UNPCKLPD", NULL, NULL},  
    { /* UNPCKHPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F8, "UNPCKHPD", NULL, NULL},  
    { /* LFENCE */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "LFENCE", NULL, NULL},  
    { /* MFENCE */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "MFENCE", NULL, NULL},  
    { /* PSHUFW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PSHUFW", NULL, NULL},  
    { /* PSRLDQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I8, "PSRLDQ", NULL, NULL},  
    { /* LOADDQA */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I1, "LOADDQA", NULL, NULL},  
    { /* LOADDQU */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I1, "LOADDQU", NULL, NULL},  
    { /* STOREDQA */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "STOREDQA", NULL, NULL},  
    { /* STOREDQU */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "STOREDQU", NULL, NULL},  
    { /* VEC_INIT_V2SI */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "VEC_INIT_V2SI", NULL, NULL},  
    { /* VEC_EXT_V2SI */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, "VEC_EXT_V2SI", NULL, NULL},  
    { /* PMADDWD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "PMADDWD", NULL, NULL},  
    { /* PSLLW_MMX */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PSLLW_MMX", NULL, NULL},  
    { /* PSLLD_MMX */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "PSLLD_MMX", NULL, NULL},  
    { /* PSRLW_MMX */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PSRLW_MMX", NULL, NULL},  
    { /* PSRLD_MMX */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "PSRLD_MMX", NULL, NULL},  
    { /* PSRAW_MMX */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I2, "PSRAW_MMX", NULL, NULL},  
    { /* PSRAD_MMX */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "PSRAD_MMX", NULL, NULL},  
    { /* PAND_MMX */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "PAND_MMX", NULL, NULL},  
    { /* PANDN_MMX */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "PANDN_MMX", NULL, NULL},  
    { /* POR_MMX */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "POR_MMX", NULL, NULL},  
    { /* PXOR_MMX */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_M8I4, "PXOR_MMX", NULL, NULL},  
    { /* COMILTSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "COMILTSS", NULL, NULL},  
    { /* COMILESS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "COMILESS", NULL, NULL},  
    { /* COMIGTSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "COMIGTSS", NULL, NULL},  
    { /* COMIGESS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "COMIGESS", NULL, NULL},  
    { /* COMINEQSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "COMINEQSS", NULL, NULL},  
    { /* COMIEQSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "COMIEQSD", NULL, NULL},  
    { /* COMILTSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "COMILTSD", NULL, NULL},  
    { /* COMILESD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "COMILESD", NULL, NULL},  
    { /* COMIGTSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "COMIGTSD", NULL, NULL},  
    { /* COMIGESD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "COMIGESD", NULL, NULL},  
    { /* COMINEQSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_U4, "COMINEQSD", NULL, NULL},  
    { /* CVTPI2PS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "CVTPI2PS", NULL, NULL},  
    { /* CVTPS2PI */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CVTPS2PI", NULL, NULL},  
    { /* CVTTPS2PI */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CVTTPS2PI", NULL, NULL},  
    { /* CVTPI2PD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F8, "CVTPI2PD", NULL, NULL},  
    { /* CVTPD2PI */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CVTPD2PI", NULL, NULL},  
    { /* CVTTPD2PI */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CVTTPD2PI", NULL, NULL},  
    { /* CVTSI2SS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_F4, "CVTSI2SS", NULL, NULL},  
    { /* CVTSI642SS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_F4, "CVTSI642SS", NULL, NULL},  
    { /* CVTSS2SI */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, "CVTSS2SI", NULL, NULL},  
    { /* CVTSS2SI64 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I8, "CVTSS2SI64", NULL, NULL},  
    { /* CVTTSS2SI */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, "CVTTSS2SI", NULL, NULL},  
    { /* CVTTSS2SI64 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I8, "CVTTSS2SI64", NULL, NULL},  
    { /* CVTSI2SD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_F8, "CVTSI2SD", NULL, NULL},  
    { /* CVTSI642SD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_F8, "CVTSI642SD", NULL, NULL},  
    { /* CVTSD2SI */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, "CVTSD2SI", NULL, NULL},  
    { /* CVTSD2SI64 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I8, "CVTSD2SI64", NULL, NULL},  
    { /* CVTTSD2SI */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, "CVTTSD2SI", NULL, NULL},  
    { /* CVTTSD2SI64 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I8, "CVTTSD2SI64", NULL, NULL},  
    { /* CVTDQ2PS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "CVTDQ2PS", NULL, NULL},  
    { /* CVTPS2DQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CVTPS2DQ", NULL, NULL},  
    { /* CVTTPS2DQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CVTTPS2DQ", NULL, NULL},  
    { /* CVTDQ2PD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F8, "CVTDQ2PD", NULL, NULL},  
    { /* CVTPD2DQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CVTPD2DQ", NULL, NULL},  
    { /* CVTTPD2DQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CVTTPD2DQ", NULL, NULL},  
    { /* CVTPD2PS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "CVTPD2PS", NULL, NULL},  
    { /* CVTPS2PD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F8, "CVTPS2PD", NULL, NULL},  
    { /* CVTSD2SS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_F4, "CVTSD2SS", NULL, NULL},  
    { /* CVTSS2SD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_F8, "CVTSS2SD", NULL, NULL},  
    { /* LOADUPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "LOADUPS", NULL, NULL},  
    { /* STOREUPS */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "STOREUPS", NULL, NULL},  
    { /* LOADUPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "LOADUPD", NULL, NULL},  
    { /* STOREUPD */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "STOREUPD", NULL, NULL},  
    { /* LOADHPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "LOADHPS", NULL, NULL},  
    { /* STOREHPS */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "STOREHPS", NULL, NULL},  
    { /* LOADLPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "LOADLPS", NULL, NULL},  
    { /* STORELPS */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "STORELPS", NULL, NULL},  
    { /* MOVMSKPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, "MOVMSKPS", NULL, NULL},  
    { /* MOVMSKPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, "MOVMSKPD", NULL, NULL},  
    { /* MASKMOVDQU */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "MASKMOVDQU", NULL, NULL},  
    { /* MASKMOVQ */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "MASKMOVQ", NULL, NULL},  
    { /* MOVNTPD */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "MOVNTPD", NULL, NULL},  
    { /* MOVNTI */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "MOVNTI", NULL, NULL},  
    { /* STMXCSR */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "STMXCSR", NULL, NULL},  
    { /* LDMXCSR */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V, "LDMXCSR", NULL, NULL},  
    { /* MOVSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "MOVSD", NULL, NULL},  
    { /* PSHUFLW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PSHUFLW", NULL, NULL},  
    { /* PSHUFHW */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I2, "PSHUFHW", NULL, NULL},  
    { /* ADDSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "ADDSD", NULL, NULL},  
    { /* SUBSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "SUBSD", NULL, NULL},  
    { /* MULSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "MULSD", NULL, NULL},  
    { /* DIVSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "DIVSD", NULL, NULL},  
    { /* CMPEQSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPEQSD", NULL, NULL},  
    { /* CMPLTSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPLTSD", NULL, NULL},  
    { /* CMPLESD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPLESD", NULL, NULL},  
    { /* CMPUNORDSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPUNORDSD", NULL, NULL},  
    { /* CMPNEQSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNEQSD", NULL, NULL},  
    { /* CMPNLTSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNLTSD", NULL, NULL},  
    { /* CMPNLESD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPNLESD", NULL, NULL},  
    { /* CMPORDSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16I4, "CMPORDSD", NULL, NULL},  
    { /* MAXSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "MAXSD", NULL, NULL},  
    { /* MINSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "MINSD", NULL, NULL},  
    { /* SQRTSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_V16F4, "SQRTSD", NULL, NULL},  
#endif // TARG_X8664
    { /* F8F8I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "F8F8I4EXPEXPR", "__powidf2"},
    { /* F4F4I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "F4F4I4EXPEXPR", "__powisf2"},
#ifdef TARG_MIPS
    { /* FQFQI4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQFQI4EXPEXPR", "__powitf2"},
    { /* F16F16I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "F16F16I4EXPEXPR", "__powitf2"},
#else
    { /* FQFQI4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_FQ, NULL, "FQFQI4EXPEXPR", "__powixf2"},
    { /* F16F16I4EXPEXPR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F16, NULL, "F16F16I4EXPEXPR", "__powixf2"},
#endif
    { /* EXPECT */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
	IRETURN_I4, NULL, "EXPECT", NULL},
#ifndef TARG_X8664
    { /* FLOOR */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F8, NULL, "FLOOR", "floor"},
    { /* FLOORF */
	BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
	IRETURN_F4, NULL, "FLOORF", "floorf"},
#else /*sse4a intrinsics*/
    { /* MOVNTSS */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V, "MOVNTSS", NULL, NULL},
    { /* MOVNTSD */
        BYVAL, NOT_PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V, "MOVNTSD", NULL, NULL},
    { /* EXTRQI */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "EXTRQI", NULL, NULL},
    { /* EXTRQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "EXTRQ", NULL, NULL},
    { /* INSERTQI */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "INSERTQI", NULL, NULL},
    { /* INSERTQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "INSERTQ", NULL, NULL},
    { /* PADDD128*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PADDD128", NULL, NULL},
    { /* PADDW128*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PADDW128", NULL, NULL},
    { /* PADDQ128*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "PADDQ128", NULL, NULL},
    { /* PADDUSB128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PADDUSB128", NULL, NULL},
    { /* PADDUSW128*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PADDUSW128", NULL, NULL},
    { /* PADDSB128*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PADDSB128", NULL,NULL},
    { /*PADDSW128*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PADDSW128", NULL, NULL},
    { /* ADDSUBPS*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F4, "ADDSUBPS", NULL, NULL},
    { /* PSUBSB128*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PSUBSB128", NULL,NULL},
    { /* PSUBSW128*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PSUBSW128", NULL,NULL},
    { /* LDDQU*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "LDDQU", NULL, NULL},
    { /* MOVSHDUP*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F4, "MOVSHDUP", NULL, NULL},
    { /* MOVSLDUP*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F4, "MOVSLDUP", NULL, NULL},
    { /* HADDPD*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F8, "HADDPD", NULL, NULL},
    { /* HADDPS*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F4, "HADDPS", NULL, NULL},
    { /* HSUBPD*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F8, "HSUBPD", NULL, NULL},
    { /* HSUBPS*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F4, "HSUBPS", NULL, NULL},
    { /* ADDSUBPD*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F8, "ADDSUBPD", NULL, NULL},
    { /* PBLENDW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PBLENDW128", NULL, NULL},
    { /* BLENDPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F8, "BLENDPD", NULL, NULL},
    { /* BLENDPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "BLENDPS", NULL, NULL},
    { /* PBLENDVB128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PBLENDVB128", NULL, NULL},
    { /* BLENDVPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F8, "BLENDVPD", NULL, NULL},
    { /* BLENDVPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F4, "BLENDVPS", NULL, NULL},
    { /* ROUNDPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F8, "ROUNDPD", NULL, NULL},
    { /* ROUNDSD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F4, "ROUNDSD", NULL, NULL},
    { /* ROUNDPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F4, "ROUNDPS", NULL, NULL},
    { /* ROUNDSS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F4, "ROUNDSS", NULL, NULL},
    { /* PCMPEQQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "PCMPEQQ", NULL, NULL},
    { /* PMOVSXBW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PMOVSXBW128", NULL, NULL},
    { /* PMOVSXBD128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PMOVSXBD128", NULL, NULL},
    { /* PMOVSXBQ128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "PMOVSXBQ128", NULL, NULL},
    { /* PMOVSXWD128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PMOVSXWD128", NULL, NULL},
    { /* PMOVSXWQ128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "PMOVSXWQ128", NULL, NULL},
    { /* PMOVSXDQ128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "PMOVSXDQ128", NULL, NULL},
    { /* PMOVZXBW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PMOVZXBW128", NULL, NULL},
    { /* PMOVZXBD128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PMOVZZBD128", NULL, NULL},
    { /* PMOVZXBQ128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "PMOVSZBQ128", NULL, NULL},
    { /* PMOVZXWD128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PMOVSZWD128", NULL, NULL},
    { /* PMOVZXWQ128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "PMOVSZWQ128", NULL, NULL},
    { /* PMOVZXDQ128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "PMOVSZDQ128", NULL, NULL},
    { /* PACKUSDW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PACKUSDW128", NULL, NULL},
    { /* DPPD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F8, "DPPD", NULL, NULL},
    { /* DPPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F4, "DPPS", NULL, NULL},
    { /* MPSADBW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "MPSADBW128", NULL, NULL},
    { /* PMULDQ128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "PMULDQ128", NULL, NULL},
    { /* PMULLD128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PMULLD128", NULL, NULL},
    { /* PEXTRB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PEXTRB", NULL, NULL},
    { /* PEXTRD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PEXTRD", NULL, NULL},
    { /* PEXTRQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I8, "PEXTRQ", NULL, NULL},
    { /*VEC_EXT_V4SF*/
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
		IRETURN_F4, "VEC_EXT_V4SF", NULL, NULL},
    { /* EXTRACTPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "EXTRACTPS", NULL, NULL},
    { /* PINSRB */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PEXTRB", NULL, NULL},
    { /* PINSRD */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PEXTRD", NULL, NULL},
    { /* PINSRQ */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "PEXTRQ", NULL, NULL},
    { /* INSERTPS */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16F4, "INSERTPS", NULL, NULL},
    { /* PMAXSB128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PMAXSB128", NULL, NULL},
    { /* PMAXSD128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PMAXSD128", NULL, NULL},
    { /* PMAXUW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PMAXUW128", NULL, NULL},
    { /* PMAXUD128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PMAXUD128", NULL, NULL},
    { /* PMINSB128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PMINSB128", NULL, NULL},
    { /* PMINSD128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PMINSD128", NULL, NULL},
    { /* PMINUW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PMINUW128", NULL, NULL},
    { /* PMINUD128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PMINUD128", NULL, NULL},
    { /* PHMINPOSUW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PHMINPOSUW128", NULL, NULL},
    { /* MOVNTDQA, */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "MOVNTDQA", NULL, NULL},
    { /* PTESTC128, */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PTESTC128", NULL, NULL},
    { /* PTESTNZC128, */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PTESTNZC128", NULL, NULL},
    { /* PTESTZ128, */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PTESTZ128", NULL, NULL},
    { /* PCMPESTRIA128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PCMPESTRIA128", NULL, NULL},
    { /* PCMPESTRIC128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PCMPESTRIC128", NULL, NULL},
    { /* PCMPESTRI128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PCMPESTRI128", NULL, NULL},
    { /* PCMPESTRM128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PCMPESTRM128", NULL, NULL},
    { /* PCMPESTRIO128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PCMPESTRIO128", NULL, NULL},
    { /* PCMPESTRIS128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PCMPESTRIS128", NULL, NULL},
    { /* PCMPESTRIZ128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PCMPESTRIZ128", NULL, NULL},
    { /* PCMPGTQ128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "PCMPGTQ128", NULL, NULL},
    { /* PCMPISTRIA128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PCMPISTRIA128", NULL, NULL},
    { /* PCMPISTRIC128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PCMPISTRIC128", NULL, NULL},
    { /* PCMPISTRI128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PCMPISTRI128", NULL, NULL},
    { /* PCMPISTRM128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PCMPISTRM128", NULL, NULL},
    { /* PCMPISTRIO128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PCMPISTRIO128", NULL, NULL},
    { /* PCMPISTRIS128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PCMPISTRIS128", NULL, NULL},
    { /* PCMPISTRIZ128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PCMPISTRIZ128", NULL, NULL},
    { /* CRC32B */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_U1, "CRC32B", NULL, NULL},
    { /* CRC32W */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_U2, "CRC32W", NULL, NULL},
    { /* CRC32L */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_U4, "CRC32L", NULL, NULL},
    { /* CRC32Q */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_U8, "CRC32Q", NULL, NULL},
    {/*SETREPI32*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
		IRETURN_V16I4, "SETREPI32", NULL, NULL},
    {/*SETREPI16*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
		IRETURN_V16I2, "SETREPI16", NULL, NULL},
    {/*SETREPI8*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
		IRETURN_V16I1, "SETREPI8", NULL, NULL},
    { /* PHADDW128 */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PHADDW128", NULL, NULL},
    { /* PHADDD128 */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PHADDD128", NULL, NULL},
    { /* PHADDSW128 */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PHADDSW128", NULL, NULL},
    { /* PHADDW */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I2, "PHADDW", NULL, NULL},
    { /* PHADDD */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I4, "PHADDD", NULL, NULL},
    { /* PHADDSW */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I2, "PHADDSW", NULL, NULL},
    { /* PHSUBW128 */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PHSUBW128", NULL, NULL},
    { /* PHSUBD128 */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PHSUBD128", NULL, NULL},
    { /* PHSUBSW128 */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PHSUBSW128", NULL, NULL},
    { /* PHSUBW */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I2, "PHSUBW", NULL, NULL},
    { /* PHSUBD */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I4, "PHSUBD", NULL, NULL},
    { /* PHSUBSW */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I2, "PHSUBSW", NULL, NULL},
    { /* PABSB128 */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PABSB128", NULL, NULL},
    { /* PABSW128 */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PABSW128", NULL, NULL},
    { /* PABSD128 */
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I4, "PABSD128", NULL, NULL},
    { /* PABSB*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I1, "PABSB", NULL, NULL},
    { /* PABSW*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I2, "PABSW", NULL, NULL},
    { /* PABSD*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I4, "PABSD", NULL, NULL},
    { /* PMADDUBSW128*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PMADDUBSW128", NULL, NULL},
    { /* PMADDUBSW*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I2, "PMADDUBSW", NULL, NULL},
    { /* PMULHRSW128*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I2, "PMULHRSW128", NULL, NULL},
    { /* PMULHRSW*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I2, "PMULHRSW", NULL, NULL},
    { /* PALIGNR128*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "PALIGNR128", NULL, NULL},
    { /* PALIGNR*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I4, "PALIGNR", NULL, NULL},
    { /* PSHUFB128*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PSHUFB128", NULL, NULL},
    { /* PSHUFB*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I1, "PSHUFB", NULL, NULL},
    { /* AESDEC*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "AESDEC", NULL, NULL},
    { /* AESENC*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "AESENC", NULL, NULL},
    { /* AESDECLAST*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "AESDECLAST", NULL, NULL},
    { /* AESENCLAST*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "AESENCLAST", NULL, NULL},
    { /* AESIMC*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "AESIMC", NULL, NULL},
    { /* AESKEYGENASSIST*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "AESKEYGENASSIST", NULL, NULL},
    { /* PCLMULDQD*/
        BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I8, "PCLMULDQD", NULL, NULL},
/*AVX*/
   // { /* ADDPD256*/
   //     BYVAL, PURE, SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
   //     IRETURN_V32F8, "ADDPD256", NULL, NULL},
#include "intrn_info_avx.cxx"
    { /* PAND128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PAND128", NULL, NULL},
    { /* PANDN128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PANDN128", NULL, NULL},
    { /* POR128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "POR128", NULL, NULL},
    { /* PEXTRW64 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PEXTRW64", NULL, NULL},
    { /* PEXTRW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_I4, "PEXTRW128", NULL, NULL},
    { /* PINSRW64 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_M8I1, "PINSRW64", NULL, NULL},
    { /* PINSRW128 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, CGINTRINSIC,
        IRETURN_V16I1, "PINSRW128", NULL, NULL},
    { /* V16F8LOG10 */
        BYVAL, PURE, NO_SIDEEFFECTS, DOES_RETURN, NOT_ACTUAL, NOT_CGINTRINSIC,
        IRETURN_V16F4, NULL, "V16F4LOG10", "__vrs4_log10f"},
#endif
#endif // KEY
};

